<script setup lang="ts">
    import { onUnmounted, ref, watch } from 'vue'
    import 'leaflet/dist/leaflet.css'
    import L, {
        LatLngExpression,
        LatLngLiteral,
        Marker,
        ZoomPanOptions,
    } from 'leaflet'
    import 'leaflet-gesture-handling/dist/leaflet-gesture-handling.css'
    import { VInput } from 'vuetify/lib/components/index.mjs'
    import { useLeafletMap } from '../composables/useLeafletMap'
    import { isMobile } from '@/shared/helpers/device'
    import { isDefined, isUndefined } from '@/shared/helpers/types'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { useApproximateAddress } from '@/shared/geocoding/composables/useApproximateAddress'

    const name = 'MapPickerComponent'
    const msal = useMsal()
    const interventionMarker = ref<Marker>()
    const mapContainerId = 'mapPickerContainer-' + self.crypto.randomUUID()
    let geolocationWatchHandlerId: null | number = null

    interface Props {
        height: string
        defaultViewOptions?: {
            center?: LatLngExpression
            zoom?: number
            options?: ZoomPanOptions
        }
        rules?: VInput['rules']
        preventDrag?: boolean
    }

    const props = withDefaults(defineProps<Props>(), {
        height: () => '500px',
        defaultViewOptions: () => {
            return {
                zoom: 10,
            }
        },
        rules: () => [],
        preventDrag: false,
    })
    const coordinates = defineModel<LatLngLiteral | undefined>()
    const { map, changeMapLayer } = useLeafletMap({
        containerId: mapContainerId,
        viewOptions: props.defaultViewOptions,
        preventDrag: props.preventDrag,
    })

    const { approximateAddress } = useApproximateAddress(coordinates, msal)

    function setMarker(interventionLocation: LatLngLiteral) {
        if (isUndefined(map.value)) {
            return
        }

        if (isUndefined(interventionMarker.value)) {
            interventionMarker.value = L.marker(interventionLocation)
            interventionMarker.value.addTo(map.value)

            interventionMarker.value
                .getElement()
                ?.setAttribute('data-cy', 'intervention-marker')

            interventionMarker.value.on('click', () => {
                coordinates.value = undefined
            })
        }

        interventionMarker.value.setLatLng(interventionLocation)
    }

    function removeMarker() {
        if (isUndefined(interventionMarker.value)) {
            return
        }
        // @ts-expect-error on ne sait pas trop pk mais ts n'aime pas mettre les map leaflet en ref...
        interventionMarker.value.removeFrom(map.value)
        interventionMarker.value = undefined
    }

    function pickPosition(interventionLocation: LatLngLiteral) {
        coordinates.value = interventionLocation
    }

    // met à jour le visuel du marqueur en fonction du modèle
    watch(
        [coordinates, map],
        () => {
            if (isUndefined(map)) {
                return
            }
            if (isUndefined(coordinates.value)) {
                removeMarker()
            } else {
                setMarker(coordinates.value)
            }
        },
        { immediate: true }
    )

    watch(map, () => {
        if (isUndefined(map.value)) {
            return
        }

        if (coordinates.value) {
            // si nous avons déjà des coordonées fournies, on place le marqueur
            map.value.setView(coordinates.value, 18)
            map.value.setZoom(Math.min(map.value.getZoom(), 18))
        } else if ('geolocation' in navigator && isMobile()) {
            // On choisi de positionner automatiquement l'intervention sur la position de l'utilisateur
            // si on accède à silab de puis un device mobile
            navigator.geolocation.getCurrentPosition((position) => {
                if (isUndefined(map.value)) {
                    return
                }
                const currenCoordinatesLatLng = {
                    lat: position.coords.latitude,
                    lng: position.coords.longitude,
                }
                pickPosition(currenCoordinatesLatLng)
                map.value.setView(currenCoordinatesLatLng, 18)
                map.value.setZoom(Math.min(map.value.getZoom(), 18))
            })
        }
        map.value.on('click', (e) => {
            pickPosition(e.latlng)
        })
    })

    // Note: onUnmounted semble être le bon hook : https://vuejs.org/api/composition-api-lifecycle.html#onunmounted
    onUnmounted(() => {
        if (geolocationWatchHandlerId !== null) {
            navigator.geolocation.clearWatch(geolocationWatchHandlerId)
        }
        if (isDefined(map.value)) {
            map.value.remove()
        }
    })
</script>

<template>
    <div class="position-relative">
        <div
            :id="mapContainerId"
            :data-cy="`component-${name}`"
            :style="{ height: height }"
        >
            <div
                v-if="isDefined(approximateAddress.data)"
                class="map-address-box"
            >
                <v-icon icon="mdi-map-outline" /> {{ approximateAddress.data }}
            </div>
        </div>
        <div
            class="position-absolute top-0 left-0 right-0 d-flex"
            style="height: 50px; z-index: 1000; pointer-events: none"
        >
            <div class="flex-grow-1 pa-2">
                <div style="pointer-events: initial">
                    <slot name="topOverlay"></slot>
                </div>
            </div>
            <div
                class="flex-grow-0 flex-shrink-0"
                style="pointer-events: initial"
            >
                <button
                    v-if="isDefined(coordinates)"
                    class="silab-leaflet-control mt-2 mr-2 mb-2"
                    style="pointer-events: initial; font-size: 12px"
                    data-cy="reset-location-button"
                    @click.prevent="coordinates = undefined"
                >
                    <v-icon icon="mdi-trash-can-outline"></v-icon>
                </button>
                <button
                    class="silab-leaflet-control mt-2 mr-2 mb-2"
                    style="pointer-events: initial; font-size: 12px"
                    @click.prevent="changeMapLayer()"
                >
                    <v-icon icon="mdi-layers-outline"></v-icon>
                </button>
            </div>
        </div>
        <v-input
            :rules="rules"
            :validation-value="interventionMarker?.getLatLng().toString()"
            hide-details
        ></v-input>
    </div>
</template>
<style scoped lang="scss">
    @use '../styles/style.scss';
</style>
